import Vue from 'vue'
import Vuex from 'vuex'

Vue.use(Vuex)

const store = new Vuex.Store({
  state: {
    userInfo: '',
    accessToken: '',
    userId: '',
    loginAccount: '',
    employeeId: '',
    employeeName: '',
    employeeNum: '',
    tenantId: '',
    tenantName: '',
  },
  getters: {
    getUserInfo: state => {
      return state.userInfo
    },
    getToken: state => {
      return state.accessToken
    },
    getUserId: state => {
      return state.userId
    },
    getLoginAccount: state => {
      return state.loginAccount
    },
    getEmployeeId: state => {
      return state.employeeId
    },
    getEmployeeName: state => {
      return state.employeeName
    },
    getEmployeeNum: state => {
      return state.employeeNum
    },
    getTenantId: state => {
      return state.tenantId
    },
    getTenantName: state => {
      return state.tenantName
    },
  },
  mutations: {
    setUserInfo: (state, userInfo) => {
      state.userInfo = userInfo
      this.commit('setToken', userInfo.token)
      this.commit('setUserId', userInfo.userId)
      this.commit('setLoginAccount', userInfo.loginAccount)
      this.commit('setEmployeeId', userInfo.employeeId)
      this.commit('setEmployeeName', userInfo.employeeName)
      this.commit('setEmployeeNum', userInfo.employeeNum)
      this.commit('setTenantId', userInfo.tenantId)
      this.commit('setTenantName', userInfo.tenantName)
    },
    setToken: (state, token) => {
      localStorage.setItem('access_token', token)
      state.accessToken = token
    },
    setUserId: (state, userId) => {
      state.userId = userId
    },
    setLoginAccount: (state, loginAccount) => {
      state.loginAccount = loginAccount
    },
    setEmployeeId: (state, employeeId) => {
      state.roles = employeeId
    },
    setEmployeeName: (state, employeeName) => {
      state.employeeName = employeeName
    },
    setEmployeeNum: (state, employeeNum) => {
      state.employeeNum = employeeNum
    },
    setTenantId: (state, tenantId) => {
      localStorage.setItem('tenantId', tenantId)
      state.tenantId = tenantId
    },
    setTenantName: (state, tenantName) => {
      state.tenantName = tenantName
    },
  },
  actions: {
    // 登录
    getUserInfo ({ commit }) {
      window.onSuccess = function (message) {
        let userInfo = JSON.parse(message)
        commit('setUserInfo', userInfo)
      }
      window.onError = function (message) {
        var argument = {
          className: 'BaseBridge',
          function: 'closeWebView',
          successCallBack: 'closeSuccess',
          failCallBack: 'closeError',
        }
        HandBridge.postMessage(JSON.stringify(argument))
      }
      let params = {
        className: 'BaseBridge',
        function: 'getBaseInfo',
        successCallBack: 'onSuccess',
        failCallBack: 'onError',
      }
      HandBridge.postMessage(JSON.stringify(params))
    },
  },

})

export default store
